Option Strict On
Option Explicit On 

Imports System.IO

Friend Class CollectionUris
    Inherits System.Collections.CollectionBase

    Public Sub Add(ByVal amember As DownloadUri)
        List.Add(amember)
    End Sub

    Public Sub RemoveTop()
        If Me.Count > 0 Then List.RemoveAt(0)
    End Sub

    Default Public ReadOnly Property Item(ByVal i As Integer) As DownloadUri
        Get
            If (i > Count - 1) Or (i < 0) Then
                Return Nothing
            Else
                Return CType(List.Item(i), DownloadUri)
            End If
        End Get
    End Property

    Public ReadOnly Property SaveFile() As fileinfo
        Get
            If Me.Count = 0 Then
                Return Nothing
            Else
                Return Me(0).SaveFile
            End If
        End Get
    End Property

    Public ReadOnly Property Referer() As Uri
        Get
            If Me.Count = 0 Then
                Return Nothing
            Else
                Return Me(0).Referer
            End If
        End Get
    End Property

    Public ReadOnly Property TopURL() As String
        Get
            If Me.Count > 0 Then
                Return Me(0).AbsoluteUri
            Else
                Return Nothing
            End If
        End Get
    End Property

    Public ReadOnly Property TopURLFileName() As String
        Get
            If Me.Count > 0 Then
                Dim strUriSegments() As String = Me(0).Segments
                Return strUriSegments(strUriSegments.Length - 1)
            Else
                Return Nothing
            End If
        End Get
    End Property
End Class
